﻿
# include <fcntl.h>


# include "MyClass.h"
# include "qmultimedia.h"


int play = 0;

unsigned int found = 0;

MyClass * eh;
QWidget * window;
QSlider * slider, * slider1;
QLabel * l;
QProgressBar * progress; 

MyClass::MyClass(QObject *parent): QObject(parent){}
MyClass::~MyClass(){}

unsigned int length = 0, position = 0, cposition = 0;

typedef struct
{
	unsigned char r, v;
	unsigned int p;
} MUSIC_T;

# define MAX_HOURS 5
# define MUSIC_MAX_LEN MAX_HOURS*60*60*50*15

MUSIC_T music[MUSIC_MAX_LEN];

typedef struct
{
	unsigned char r[16];
	MUSIC_T * p;
} POINTERS_T;

POINTERS_T pointers[MAX_HOURS*60*60*50];

MUSIC_T * current;

void MessageBoxErr(QString a)
{
	QMessageBox msgBox;
	msgBox.setText(a);
	msgBox.setIcon(QMessageBox::Critical);
	msgBox.setWindowTitle("PSG cutter");
	msgBox.exec();
}


char * n2s(unsigned int len, char * n2rv)
{
	unsigned int secs;
	unsigned int ms;
	unsigned int min;
	unsigned int hour;

	ms   = len%50*20;
	secs = len/50;
	min  = secs/60;
	hour = min/60;

	//printf ("len=%d ms=%d secs=%d min=%d hour=%d\n", len, ms, secs, min, hour);

	min -= hour*60;
	secs=len/50 - hour*3600 - min*60;


	sprintf (n2rv, "%d:%02d:%02d.%03d", hour, min, secs, ms);

	return n2rv;
}

void show_props(void)
{
	char m1[100], m2[100], m3[100];
	char m[200];

	sprintf (m, "Play position=%s, Cut position=%s, Length=%s", n2s(position, m1), n2s(cposition, m3), n2s(length, m2));

	l->setText(m);
}

QString fromutf(char * arg)
{
	if (!arg)
		return ("");

	return (QDir::fromNativeSeparators(QString::fromUtf8(arg)));
}

QList <QFile *> list;

int io_open (char * dir, char * filename, int mode)
{
	QString filename1("");
	QString nd;
	QString nf;


	if (dir)
		nd=QDir::fromNativeSeparators(fromutf(dir));

	if (filename)
		nf=fromutf(filename);

	if (dir)
	{
		QDir * d = new QDir(nd);

		if( !d->exists() )
		{
			printf("io_open : Directory does not exist - %s", nd.toLocal8Bit().data());
			return -1;
		}

		filename1 += QDir::fromNativeSeparators(nd);
		filename1 += QString("/");
		filename1 += QDir::fromNativeSeparators(nf);
	}
	else
	{
		filename1 += QDir::fromNativeSeparators(nf);
	}

	QFile * f = new QFile(filename1);

	if( !f->exists() )
	{
		printf ("The file does not exist %s", filename1.toLocal8Bit().data());
		return -1;
	}

	QIODevice::OpenMode omode;

	if (mode == O_RDONLY) omode = QIODevice::ReadOnly;
	if (mode == O_WRONLY) omode = QIODevice::WriteOnly;
	if (mode == O_RDWR) omode = QIODevice::ReadWrite;

	if(!f->open(omode))
	{
		printf ("Failed to open %s", filename);
		return -1;
	}

	list << f;

	return (list.size() - 1);
}

long long io_read (int fd, char * buffer, long long size)
{
	return (list[fd]->read(buffer, size));
}

qint64 io_fsize (int fd)
{
	return (list[fd]->size());
}

long long io_lseek (int fd, long long pos, int mode)
{
	if (mode == SEEK_CUR)
		pos += list[fd]->pos();

	if (mode == SEEK_END)
		pos += io_fsize(fd);


	if (list[fd]->seek(pos) == true)
		return pos;
	else
		return -1;
}

int io_eof (int fd)
{
	return (list[fd]->atEnd ());
}

void io_close (int fd)
{
	list[fd]->close();
}


void PF(char * Filename, int fil1, int rew)
{
	int fil;
	static unsigned int counter = 0;
	unsigned int counter1 = 0;
	unsigned char c, v;
	char m[100];

	unsigned char r[16] = {0};


	if (Filename)
		fil = io_open(0, Filename, O_RDONLY);
	else
		fil = fil1;

	if (fil==-1)
	{
		char em[3000];
		sprintf (em, "Can't open %s\n!", Filename);
		MessageBoxErr(em);
		return;
	}

	if (rew)
		::position = length = counter = found = 0;

	for (int j=0; j<16; j++)
		pointers[0].r[j] = 0;

	io_lseek(fil, 16, SEEK_SET);

	while (!io_eof(fil))
	{
		io_read(fil, (char *)&c, 1);

		switch (c)
		{
		case 0:
		case 1:
		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
		case 14:
		case 15:

			io_read(fil, (char *)&v, 1);

			r[c]=v;

			music[counter].r = c;
			music[counter].v = v;
			music[counter].p = length;

			if (counter1<10)
			{
				//printf ("%d %d %d\n", music[counter].r, music[counter].v, music[counter].p);
			}

			counter++;
			counter1++;

			if (counter>MUSIC_MAX_LEN)
			{
				MessageBoxErr("MUSIC_MAX_LEN is reached!");
				exit (-4);
			}

			break;

		case 254:

			io_read(fil, (char *)&c, 1);

			for (int i=0; i<c*4; i++)
			{
				length++;				
				pointers[length].p= &music[counter];

				for (int j=0; j<16; j++)
					pointers[length].r[j] = r[j];
			}

			if (length>MUSIC_MAX_LEN/15)
			{
				MessageBoxErr("MUSIC_MAX_LEN is reached!");
				exit (-4);
			}


			break;

		case 255:

			length++;				
			pointers[length].p = &music[counter];

			for (int j=0; j<16; j++)
				pointers[length].r[j] = r[j];

			if (length>MUSIC_MAX_LEN/15)
			{
				MessageBoxErr("MUSIC_MAX_LEN is reached!");
				exit (-4);
			}

			break;

		default:
			sprintf(m, "Wrong CMD 0x%x (0x%x)", c, io_lseek(fil, -1, SEEK_CUR));
			MessageBoxErr(m);
			io_close(fil);
			return;
		}
	}

	io_close(fil);

	show_props();

	slider->setRange(0, length);
	slider->setSliderPosition(0);

	slider1->setRange(0, length);
	slider1->setSliderPosition(0);

	current = &music[0];
	pointers[0].p= &music[0];
	cposition = 0;
}


void MyClass::openfile()
{
	QFileDialog::Options options;
	QString selectedFilter;

	QFileDialog * fd = new QFileDialog();

	QString fileName = fd->getOpenFileName(window,
		"",
		"",
		tr("Supported files (*.PSG)"),
		&selectedFilter,
		options); 

	if ((!fileName.size()))
	{
	}
	else
	{
		QByteArray ba  = fileName.toUtf8();
		char * s = (char *)ba.constData();

		PF(s, 0, 1);
	}
}

int io_creat (char * dir, char * filename)
{
	QString filename1("");
	QString nd;
	QString nf;


	if (dir)
		nd=QDir::fromNativeSeparators(fromutf(dir));

	if (filename)
		nf=fromutf(filename);

	if (dir)
	{
		QDir * d = new QDir(nd);

		if( !d->exists() )
		{
			printf("io_creat : Directory does not exist\n");
			return -1;
		}

		filename1 += QDir::fromNativeSeparators(nd);

		if (strlen(dir))
			filename1 += QString("/");

		filename1 += QDir::fromNativeSeparators(nf);
	}
	else
	{
		filename1 += QDir::fromNativeSeparators(nf);
	}

	QFile * f = new QFile(filename1);

	if(!f->open(QIODevice::ReadWrite ))
	{
		printf("Failed to create %s\n", filename);
		return -1;
	}

	f->resize(0);

	list << f;

	return (list.size() - 1);
}

int io_creat_temp()
{
	QTemporaryFile * f = new QTemporaryFile;

	if(!f->open())
	{
		MessageBoxErr("Failed to create tempfiles\n");
		return -1;
	}

	f->resize(0);

	list << f;

	return (list.size() - 1);
}

long long io_write (int fd, unsigned char * buffer, long long size)
{
	return (list[fd]->write((char *)buffer, size));
}

int SavePSG(char * filename, unsigned int start, unsigned int end)
{
	unsigned char a = 255;
	MUSIC_T * m;
	unsigned char PSG[16]={0x50, 0x53, 0x47, 0x1A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	int file;


	if (filename)
		file = io_creat("", filename);
	else
		file = io_creat_temp();

	if (file == -1)
	{
		MessageBoxErr("Can't ceate file!");
		return -1;
	}

	io_write(file, PSG, 16);

	for (unsigned int i=start; i<end; i++)
	{
		m = pointers[i].p;

		while (m->p == i)
		{
			io_write(file, &m->r, 1);
			io_write(file, &m->v, 1);

			m++;
		}

		io_write(file, &a, 1);
	}

	if (filename)
		io_close(file);

	return file;
}

void MyClass::savefile()
{
	if (!slider1->sliderPosition())
	{
		MessageBoxErr ("Zero cut position");
		return;
	}

	QFileDialog::Options options;
	QString selectedFilter;

	QString fileName = QFileDialog::getSaveFileName(window,
		"PSG_Cutter",
		"",
		tr("PSG files (*.psg)"),
		&selectedFilter,

		options); 

	if (!fileName.isEmpty())
	{
		QByteArray ba  = fileName.toUtf8();
		char * s = (char *)ba.constData();

		char fn[1028];

		if (!qstricmp(&s[strlen(s)-4], ".psg"))
			strcpy(fn, s);
		else
		{
			strcpy(fn, s);
			strcat(fn , ".psg");
		}

		SavePSG(fn, 0, cposition);	

		strcpy (&fn[strlen(fn)-4], ".rest.psg");

		SavePSG(fn, cposition, length);

		PF(fn, 0, 1);
	}
}

void MyClass::set()
{
	slider1->setSliderPosition(::position);
}

void MyClass::position1(int p)
{
	cposition = p;
	show_props();	
}

void MyClass::cut()
{
	if (!slider1->sliderPosition())
	{
		MessageBoxErr ("Zero cut position");
		return;
	}

	QMessageBox msgBox;
	msgBox.setWindowTitle("PSG_cutter");
	msgBox.setText("Cut?");
	msgBox.setStandardButtons(QMessageBox::Yes);
	msgBox.addButton(QMessageBox::No);
	msgBox.setDefaultButton(QMessageBox::No);
	if(msgBox.exec() == QMessageBox::Yes)
	{
		int fn = SavePSG(NULL, cposition, length);
		PF(NULL, fn, 1);
	}
	else 
	{
		// do something else
	}
}

void MyClass::play1()
{	
	show_props();
	play = 1;
}



void MyClass::play3()
{
	::position = 0;
	show_props();
	current = pointers[0].p;
	play = 1;	
}

void MyClass::stop()
{
	play = 0;
}


#if QT_VERSION >= 0x040600
AudioTest * qaudio = NULL;
Generator * generator = NULL;
#endif

QQueue<char> queue;

AudioTest::AudioTest()
{
	m_format.setFrequency(44100);
	m_format.setChannels(2);
	m_format.setSampleSize(16);
	m_format.setCodec("audio/pcm");
	m_format.setByteOrder(QAudioFormat::LittleEndian);
	m_format.setSampleType(QAudioFormat::SignedInt);

	QAudioDeviceInfo info(QAudioDeviceInfo::defaultOutputDevice());

	if (!info.isFormatSupported(m_format)) 
	{
		MessageBoxErr("Format is not supported \n");
		exit (-4);
	}

	m_audioOutput = new QAudioOutput(info, m_format, this);

	if (!m_audioOutput)
	{
		MessageBoxErr("Error opening audio device \n");
		exit (-4);
	}


	m_audioOutput->setBufferSize (44100);

	m_audioOutput->start(generator);
}

Generator::Generator()
	:   QIODevice()
	,   m_pos(0)
{

}

qint64 Generator::readData(char *data, qint64 len)
{
	int i;
	int empty = 0;

	static char last = 0;


	for(i=0; i<len; i++)
	{
		if (!empty)
		{
			if (queue.isEmpty ())
			{
				empty = 1;
			}
		}

		if (!empty)
		{
			data[i] = queue.dequeue();
			last = data[i];
		}
		else
		{
			data[i] =last;
		}
	}

	return len;
}

qint64 Generator::writeData(const char *data, qint64 len)
{
	Q_UNUSED(data);
	Q_UNUSED(len);

	return 0;
}

void Generator::start()
{
	open(QIODevice::ReadOnly);
}

void Generator::stop()
{
	m_pos = 0;
	close();
}



int SoundCardInit(void)
{
	queue.clear();


#if QT_VERSION >= 0x040600
	if (generator) 	delete (generator);
	if (qaudio) 	delete (qaudio);

	generator = new Generator;
	generator->start();
	qaudio = new AudioTest;

	return(qaudio->error);
#endif
}


QTimer * timer;

# define SOUND_TICKS_PER_FRAME_MAX 10000
# define SOUND_TICKS_PER_FRAME 882

# define AY_AFINE	    (0)
# define AY_ACOARSE     (1)
# define AY_BFINE	    (2)
# define AY_BCOARSE     (3)
# define AY_CFINE	    (4)
# define AY_CCOARSE	    (5)
# define AY_NOISEPER    (6)
# define AY_ENABLE	    (7)
# define AY_AVOL	    (8)
# define AY_BVOL	    (9)
# define AY_CVOL	    (10)
# define AY_EFINE	    (11)
# define AY_ECOARSE	    (12)
# define AY_ESHAPE	    (13)
# define AY_PORTA	    (14)

unsigned short sound_buffer[SOUND_TICKS_PER_FRAME_MAX*2*2] = {0}; 

unsigned char Regs1[16];

unsigned int GeneratorA_period;
unsigned int GeneratorB_period;
unsigned int GeneratorC_period;

unsigned char channelA_enabled;
unsigned char channelB_enabled;
unsigned char channelC_enabled;

unsigned char noiseA_enabled;
unsigned char noiseB_enabled;
unsigned char noiseC_enabled;

unsigned int GeneratorA_counter;
unsigned int GeneratorB_counter;
unsigned int GeneratorC_counter;

unsigned char Atone;
unsigned char Anoice;

unsigned char Btone;
unsigned char Bnoice;

unsigned char Ctone;
unsigned char Cnoice;

unsigned int NoiceA_counter;
unsigned int NoiceB_counter;
unsigned int NoiceC_counter;

long int rndA;
long int rndB;
long int rndC;


# define STEP 800
unsigned int UpdateStep = (unsigned int)(((double)STEP * (double)44100 * (double)8) / (double)1773400 * (double)2);

unsigned char avol_max=0, bvol_max=0, cvol_max=0;
unsigned int PeriodN, periodE;
unsigned char cont,att,alt,hold;
unsigned char env_volume;
unsigned int Envelope_counter;
unsigned char up, holded;

unsigned short * mixing_ch[10];

unsigned short VolTable[16]=
{
	0x0000/2, 0x0344/2, 0x04BC/2, 0x06ED/2, 
	0x0A3B/2, 0x0F23/2, 0x1515/2, 0x2277/2, 
	0x2898/2, 0x4142/2, 0x5B2B/2, 0x726C/2, 
	0x9069/2, 0xB555/2, 0xD79B/2, 0xFFFF/2 
};

int PSGcounter=0;

typedef struct 
{
	unsigned char r;
	unsigned char v;
} AY8910_STEPS;

# define SOUND_ARRAY_LEN 1000

AY8910_STEPS PSGARRAY[SOUND_ARRAY_LEN];	

unsigned short soundA[SOUND_TICKS_PER_FRAME_MAX*2];
unsigned short soundB[SOUND_TICKS_PER_FRAME_MAX*2];
unsigned short soundC[SOUND_TICKS_PER_FRAME_MAX*2];

void * GetSoundBuffer(void)
{
	return ((void *)sound_buffer);
}

void MyClass::play2()
{
	if (!cposition)
	{
		QMessageBox msgBox;
		msgBox.setWindowTitle("PSG_cutter");
		msgBox.setText("Cut position is 0. Play from Begin?");
		msgBox.setStandardButtons(QMessageBox::Yes);
		msgBox.addButton(QMessageBox::No);
		msgBox.setDefaultButton(QMessageBox::No);
		
		if(msgBox.exec() == QMessageBox::Yes)
		{
			// do something
		}
		else 
		{
			return;
		}
	}

	::position = cposition;
	show_props();
	current = pointers[cposition].p;

	for (int i=0; i<13; i++)
	{
		PSGARRAY[PSGcounter].r = i;
		PSGARRAY[PSGcounter].v = pointers[cposition].r[i];
		PSGcounter++;
	}

	play = 1;
}

void MyClass::position(int p)
{
	::position = p;
	show_props();
	current = pointers[p].p;

	if (play)
	{
		for (int i=0; i<13; i++)
		{
			PSGARRAY[PSGcounter].r = i;
			PSGARRAY[PSGcounter].v = pointers[p].r[i];
			PSGcounter++;
		}
	}
}

void UpdateSoundBuffer(void);

void MyClass::timer_update()
{
	char * sound;


	if (!play)
		return;

	if (!length)
		return;

	if (!current)
		return;

	if (::position == length)
	{
		stop();
		return;
	}

	while (current->p == ::position)
	{
		PSGARRAY[PSGcounter].r = current->r;
		PSGARRAY[PSGcounter].v = current->v;
		PSGcounter++;
		current++;
	}		

	::position++;

	if (::position>length)
		::position = length;

	slider->setSliderPosition(::position);

	UpdateSoundBuffer();

	sound = (char *) GetSoundBuffer();

	for (int i=0; i<882*4; i++)
		queue.enqueue(sound[i]);	
}

void ApplySoundRegister(int r, int v)
{
	if (r<=AY_ESHAPE)
		Regs1[r]=v;

	switch( r )
	{
	case AY_AFINE:
	case AY_ACOARSE:
		Regs1[AY_ACOARSE] &= 0x0f;
		GeneratorA_period = (Regs1[AY_AFINE] + 256 * Regs1[AY_ACOARSE]) * UpdateStep / STEP;
		if (GeneratorA_period == 0)GeneratorA_period=UpdateStep / STEP;
		break;

	case AY_BFINE:
	case AY_BCOARSE:
		Regs1[AY_BCOARSE] &= 0x0f;
		GeneratorB_period = (Regs1[AY_BFINE] + 256 * Regs1[AY_BCOARSE]) * UpdateStep / STEP;
		if (GeneratorB_period == 0)GeneratorB_period=UpdateStep / STEP;

		break;

	case AY_CFINE:
	case AY_CCOARSE:
		Regs1[AY_CCOARSE] &= 0x0f;
		GeneratorC_period = (Regs1[AY_CFINE] + 256 * Regs1[AY_CCOARSE]) * UpdateStep / STEP;
		if (GeneratorC_period == 0)GeneratorC_period=UpdateStep / STEP;
		break;

	case AY_AVOL:
		Regs1[AY_AVOL] &= 0x1f;

		if (avol_max<Regs1[AY_AVOL])avol_max=Regs1[AY_AVOL];

		break;

	case AY_BVOL:
		Regs1[AY_BVOL] &= 0x1f;

		if (bvol_max<Regs1[AY_BVOL])bvol_max=Regs1[AY_BVOL];

		break;

	case AY_CVOL:
		Regs1[AY_CVOL] &= 0x1f;

		if (cvol_max<Regs1[AY_CVOL])cvol_max=Regs1[AY_CVOL];

		break;

	case AY_ENABLE: 

		if ((Regs1[AY_ENABLE]&1))
			channelA_enabled=1;
		else
			channelA_enabled=0;

		if ((Regs1[AY_ENABLE]&2))
			channelB_enabled=1;
		else
			channelB_enabled=0;

		if ((Regs1[AY_ENABLE]&4))
			channelC_enabled=1;
		else
			channelC_enabled=0;

		if ((Regs1[AY_ENABLE]&8))
			noiseA_enabled=1;
		else
			noiseA_enabled=0;

		if ((Regs1[AY_ENABLE]&16))
			noiseB_enabled=1;
		else
			noiseB_enabled=0;

		if ((Regs1[AY_ENABLE]&32))
			noiseC_enabled=1;
		else
			noiseC_enabled=0;

		break;

	case AY_NOISEPER:                                                                          
		Regs1[AY_NOISEPER] &= 0x1f;                                                    
		PeriodN = Regs1[AY_NOISEPER] * UpdateStep / STEP;                           
		if (PeriodN == 0) PeriodN = UpdateStep / STEP;                             
		break;         

	case AY_EFINE:                                                                             
	case AY_ECOARSE:                                                                           
		periodE = ((Regs1[AY_EFINE] + 256 * Regs1[AY_ECOARSE])) * UpdateStep / STEP;                                                                                               
		if (periodE == 0) periodE = UpdateStep / STEP / 2;                         
		break;      


	case AY_ESHAPE: 
		Regs1[AY_ESHAPE] &= 0x0f;  

		switch(Regs1[AY_ESHAPE])
		{
		case 0 :
		case 1 :
		case 2 :
		case 3 :
			cont=0;
			att=0;
			break;

		case 4 :
		case 5 :
		case 6 :
		case 7 :
			cont=0;
			att=1;
			break;

		case 8:
			cont=1;
			att=0;
			alt=0;
			hold=0;
			break;

		case 9:
			cont=1;
			att=0;
			alt=0;
			hold=1;
			break;

		case 10:
			cont=1;
			att=0;
			alt=1;
			hold=0;
			break;

		case 11:
			cont=1;
			att=0;
			alt=1;
			hold=1;
			break;

		case 12:
			cont=1;
			att=1;
			alt=0;
			hold=0;
			break;


		case 13:
			cont=1;
			att=1;
			alt=0;
			hold=1;
			break;

		case 14:
			cont=1;
			att=1;
			alt=1;
			hold=0;
			break;

		case 15:
			cont=1;
			att=1;
			alt=1;
			hold=1;
			break;
		}

		Envelope_counter=0;

		if (att) env_volume=0;
		else env_volume=15;

		up=att;
		holded=0;

		break;


	}	
}

void Mix(unsigned short * sound_buffer, int Sound_Freq, int smezhenie, int n, ...)
{
	va_list ap;
	int i,j;


	va_start(ap, n);

	for (i=0; i<n; i++)
		mixing_ch[i]=va_arg(ap,unsigned short *);

	switch (Sound_Freq)
	{
	case 44100:
		for (i=0; i<SOUND_TICKS_PER_FRAME; i++)
		{
			sound_buffer[i*2+smezhenie]=0;

			for (j=0; j<n; j++)
				sound_buffer[i*2+smezhenie]+=mixing_ch[j][i]/n;
		}
		break;
	}		
}

void Envelope__Step(void)
{
	if (holded) return;

	/* is it correct ??? */
	if ((alt ? periodE : (periodE*2))>Envelope_counter)
		Envelope_counter++;
	else
	{
		Envelope_counter=0;

		if (up)
		{ 
			if (env_volume<15) env_volume++;
			else
			{
				if (cont==0) 
				{
					holded=1;
					env_volume=0;
					goto LQ;
				}
				if (hold)
				{
					if (alt)env_volume=0;
					holded=1;
					goto LQ;	
				}

				if (alt)up=0;
				else env_volume=0;
			}
		}
		else
		{
			if (env_volume>0) env_volume--;
			else
			{
				if (cont==0) 
				{
					holded=1;
					goto LQ;
				}
				if (hold)
				{
					if (alt)env_volume=15;
					holded=1;
					goto LQ;	
				}
				if (alt)up=1;
				else env_volume=15;
			}
		}
	}

LQ: ;
}

void UpdateSoundBuffer(void)
{
	int i;
	int j;




	/* generim zvuk */
	j=0;
	for (i=0; i<SOUND_TICKS_PER_FRAME; i++)
	{	
		if (PSGcounter>0)
		{
			while (1)
			{
				if (j>=SOUND_ARRAY_LEN) break;
				if (j>=PSGcounter) break;

				ApplySoundRegister(PSGARRAY[j].r, PSGARRAY[j].v);				

				j++;	
			}
		}	

		/* return; */

		Envelope__Step();


		/* Generator A step */
		if (GeneratorA_counter>=GeneratorA_period)	
			GeneratorA_counter=0;

		if (GeneratorA_counter<(GeneratorA_period/2))
			Atone=1;
		else
			Atone=0;

		GeneratorA_counter++;

		/* Noice A Step */
		if (NoiceA_counter>=PeriodN)	
		{
			NoiceA_counter=0;
			rndA=qrand();
		}

		if (rndA&1)
			Anoice=1;
		else
			Anoice=0;

		NoiceA_counter++;

		soundA[i]=( ((Atone | channelA_enabled) & (Anoice | noiseA_enabled)) | !GeneratorA_period);
		soundA[i] = (soundA[i]) ? (Regs1[AY_AVOL]&0x10) ? VolTable[env_volume] : VolTable[Regs1[AY_AVOL]] : 0;

		/* Generator B step */
		if (GeneratorB_counter>=GeneratorB_period)	
			GeneratorB_counter=0;

		if (GeneratorB_counter<(GeneratorB_period/2))
			Btone=1;
		else
			Btone=0;

		GeneratorB_counter++;

		/* Noice B Step */
		if (NoiceB_counter>=PeriodN)	
		{
			NoiceB_counter=0;
			rndB=qrand ();
		}

		if (rndB&1)
			Bnoice=1;
		else
			Bnoice=0;

		NoiceB_counter++;

		soundB[i]=( ((Btone | channelB_enabled) & (Bnoice | noiseB_enabled)) | !GeneratorB_period);
		soundB[i] = (soundB[i]) ? (Regs1[AY_BVOL]&0x10) ? VolTable[env_volume] : VolTable[Regs1[AY_BVOL]] : 0;

		/* Generator C step */
		if (GeneratorC_counter>=GeneratorC_period)	
			GeneratorC_counter=0;

		if (GeneratorC_counter<(GeneratorC_period/2))
			Ctone=1;
		else
			Ctone=0;

		GeneratorC_counter++;

		/* Noice C Step */
		if (NoiceC_counter>=PeriodN)	
		{
			NoiceC_counter=0;
			rndC=qrand ();
		}

		if (rndC&1)
			Cnoice=1;
		else
			Cnoice=0;

		NoiceC_counter++;

		soundC[i]=( ((Ctone | channelC_enabled) & (Cnoice | noiseC_enabled)) | !GeneratorC_period);
		soundC[i] = (soundC[i]) ? (Regs1[AY_CVOL]&0x10) ? VolTable[env_volume] : VolTable[Regs1[AY_CVOL]] : 0;
	}

	/***** Mix & io_write *****/


	Mix(sound_buffer, 44100, 0, 2, soundA, soundB);
	Mix(sound_buffer, 44100, 1, 2, soundC, soundB);



	/****** Mix End *********/

	PSGcounter=0;
}



QGroupBox * Ramku_fon_vpane_h(char * name, QHBoxLayout * l, int n, QWidget * w, ...)
{
	va_list ap;
	va_start(ap, w);

	QWidget * w1;


	QGroupBox *groupBox = new QGroupBox(name);


	QHBoxLayout *vbox;


	if (!l)
		vbox = new QHBoxLayout;
	else
		vbox = l;

	//vbox->setAlignment(Qt::AlignHCenter);

	if (n)
		vbox->addWidget(w);

	for (int i=0; i < (n-1); i++)
	{
		w1 = va_arg(ap,  QWidget *);
		vbox->addWidget(w1);
	}

	va_end( ap );


	groupBox->setLayout(vbox);


	return groupBox;
}


void MyClass::cp()
{
	if (cposition)
	cposition --;
	
	show_props();	
}

void MyClass::cpp()
{
	if (cposition<length)
	cposition ++;

	show_props();	
}

void MyClass::append()
{
	QFileDialog::Options options;
	QString selectedFilter;

	QFileDialog * fd = new QFileDialog();

	QString fileName = fd->getOpenFileName(window,
		"",
		"",
		tr("Supported files (*.PSG)"),
		&selectedFilter,
		options); 

	if ((!fileName.size()))
	{
	}
	else
	{
		QByteArray ba  = fileName.toUtf8();
		char * s = (char *)ba.constData();

		PF(s, 0, 0);
	}
}

void MyClass::save()
{
	QFileDialog::Options options;
	QString selectedFilter;

	QString fileName = QFileDialog::getSaveFileName(window,
		"PSG_Cutter",
		"",
		tr("PSG files (*.psg)"),
		&selectedFilter,

		options); 

	if (!fileName.isEmpty())
	{
		QByteArray ba  = fileName.toUtf8();
		char * s = (char *)ba.constData();

		char fn[1028];

		if (!qstricmp(&s[strlen(s)-4], ".psg"))
			strcpy(fn, s);
		else
		{
			strcpy(fn, s);
			strcat(fn , ".psg");
		}

		SavePSG(fn, 0, length);
	}
}

typedef struct
{
	struct 
	{
		unsigned char r;
		unsigned char v;
	} c;

	unsigned int p;

} PSG_F_T;

int memcmp_PSG(PSG_F_T * f, PSG_F_T * t, unsigned int len)
{
	unsigned int i;


	for (i=0; i<len; i++)
		if ((f[i].c.r!=t[i].c.r) || (f[i].c.v!=t[i].c.v))
			return 1;

	return 0;
}

void MyClass::find()
{
	MUSIC_T * m;
	unsigned int PSGcounter = 0;

	PSG_F_T * psgarray;


	PSGcounter = 0;

	for (unsigned int i=0; i<length; i++)
	{
		m = pointers[i].p;

		while (m->p == i)
		{			
			PSGcounter ++;
			m++;
		}		
	}

	psgarray = (PSG_F_T * )malloc (PSGcounter * sizeof (PSG_F_T));

	PSGcounter = 0;

	for (unsigned int i=0; i<length; i++)
	{
		m = pointers[i].p;

		while (m->p == i)
		{
			psgarray[PSGcounter].c.r = m->r;
			psgarray[PSGcounter].c.v = m->v;
			psgarray[PSGcounter].p = i;

			PSGcounter ++;
			m++;
		}		
	}

	progress->setValue(found);

	for (unsigned int j=found; j<PSGcounter/2; j++) //start_1
	{
		//printf ("%d %d\n", j, PSGcounter/2);

		if (!(j%1000))
			progress->setValue(j*100/(PSGcounter/2));

		for (unsigned int k=j+1; k<PSGcounter; k++) //start_2
		{

#define MIN_S 15
			unsigned int i= MIN_S*50*16;
			//for (unsigned int i= MIN_S*50*16; i<PSGcounter/2; i++) //length
			{		
				if ((k+i)<PSGcounter)
				{
					if (!memcmp_PSG(&psgarray[j], &psgarray[k], i))
					{
						//printf ("found start1 = %d start2 = %d len = %d (%d)\n", j, k, i, PSGcounter);

						found = k;
						slider1->setSliderPosition(psgarray[k].p);	

						free (psgarray);
						return;
					}

				}
			}
		}
	}

	progress->setValue(100);
	free(psgarray);
	found = 0;
	MessageBoxErr ("Not found!\n");
}

int main(int argc, char **argv)
{
	eh = new MyClass();

	QApplication app(argc, argv);

	SoundCardInit();

	timer = new QTimer(window);

	eh->connect(timer, SIGNAL(timeout()), eh, SLOT(timer_update()));
	timer->start(20);


	QPushButton *loadButton = new QPushButton("&Load file");
	QPushButton *loadButton1 = new QPushButton("Appen&d file");
	QPushButton *cutButton = new QPushButton("&Cut");
	QPushButton *saveButton = new QPushButton("Cut and &Save");
	QPushButton *saveButton1 = new QPushButton("S&ave");
	QPushButton *quitButton = new QPushButton("&Quit");

	QPushButton *p1Button = new QPushButton("Pla&y");	
	QPushButton *p2Button = new QPushButton("Play from C&ut Position");
	QPushButton *p4Button = new QPushButton("Play from &Begin");
	QPushButton *p3Button = new QPushButton("S&et cut position");
	QPushButton *p5Button = new QPushButton("Cut positi&on <");
	QPushButton *p6Button = new QPushButton("Cut &position >");
	QPushButton *p7Button = new QPushButton("&Find periodic");
	QPushButton *stopButton = new QPushButton("S&top");

	progress = new (QProgressBar);

	slider = new QSlider(Qt::Horizontal);
	slider1 = new QSlider(Qt::Horizontal);
	l = new QLabel();

	QObject::connect(slider, SIGNAL(valueChanged(int)), eh, SLOT(position(int)));
	QObject::connect(slider1, SIGNAL(valueChanged(int)), eh, SLOT(position1(int)));

	slider->setRange(0, 0);
	slider->setSingleStep(1);
	slider1->setRange(0, 0);
	slider1->setSingleStep(1);

	show_props();

	QObject::connect(quitButton, SIGNAL(clicked()), qApp, SLOT(quit()));
	QObject::connect(loadButton, SIGNAL(clicked()), eh, SLOT(openfile()));
	QObject::connect(loadButton1, SIGNAL(clicked()), eh, SLOT(append()));
	QObject::connect(saveButton, SIGNAL(clicked()), eh, SLOT(savefile()));
	QObject::connect(saveButton1, SIGNAL(clicked()), eh, SLOT(save()));
	QObject::connect(cutButton, SIGNAL(clicked()), eh, SLOT(cut()));

	QObject::connect(p1Button, SIGNAL(clicked()), eh, SLOT(play1()));
	QObject::connect(p2Button, SIGNAL(clicked()), eh, SLOT(play2()));
	QObject::connect(p4Button, SIGNAL(clicked()), eh, SLOT(play3()));
	QObject::connect(p3Button, SIGNAL(clicked()), eh, SLOT(set()));
	QObject::connect(p5Button, SIGNAL(clicked()), eh, SLOT(cp()));
	QObject::connect(p6Button, SIGNAL(clicked()), eh, SLOT(cpp()));
	QObject::connect(p7Button, SIGNAL(clicked()), eh, SLOT(find()));
	QObject::connect(stopButton, SIGNAL(clicked()), eh, SLOT(stop()));


	QVBoxLayout *layout = new QVBoxLayout;

	QHBoxLayout *hlayout1 = new QHBoxLayout;
	QHBoxLayout *hlayout2 = new QHBoxLayout;


	layout->addLayout(hlayout1);

	layout->addWidget(Ramku_fon_vpane_h("Play position", NULL, 1, slider));
	layout->addWidget(Ramku_fon_vpane_h("Cut position", NULL, 1, slider1));

	layout->addWidget(l);   
	layout->addLayout(hlayout2);

	hlayout1->addWidget(loadButton);
	hlayout1->addWidget(loadButton1);
	hlayout1->addWidget(cutButton);
	hlayout1->addWidget(saveButton);
	hlayout1->addWidget(saveButton1);
	//hlayout1->addSpacing(200);
	hlayout1->addWidget(progress);
	hlayout1->addWidget(quitButton);


	hlayout2->addWidget(p1Button);	
	hlayout2->addWidget(p4Button);
	hlayout2->addWidget(p2Button);
		
	hlayout2->addWidget(p5Button);
	hlayout2->addWidget(p6Button);
	hlayout2->addWidget(p3Button);
	hlayout2->addWidget(p7Button);
	hlayout2->addWidget(stopButton);

	window = new QWidget();

	window->setLayout(layout);

	window->show();

	return app.exec();
}


# if defined _WIN32

# include <windows.h>

int WINAPI WinMain
(
	HINSTANCE hInstance,	// указатель на текущий экземпляр
	HINSTANCE hPrevInstance,	// указатель на предыдущйи запушенный экземпляр
	LPSTR lpCmdLine,		// командная строка
	int nCmdShow		// тип отображения окна программы
)
{
	main (0, NULL);
}
# endif